#ifndef INERTIAL_ELEMENT_H
#define INERTIAL_ELEMENT_H

#include "PhysicsElement.h"
#include "MyWorld.h"
/* It does not make sense to compute next state and update state of
a container or a wall because they do not change.
Therefore, we create an specialized class, InertialElement, for 
those objects where this behaivor makes sense and we use PhysicsElement for 
the others.
*/
class InertialElement: public PhysicsElement {
protected:
   InertialElement(int id): PhysicsElement(id){}

public:
   virtual void computeNextState(double delta_t, MyWorld * world)=0;
   virtual void updateState()=0;
};
#endif