#include "Spring.h"
#include "Ball.h"


int Spring::id = 0;

Spring::Spring():InertialElement(id++){
	restLength=0;
	stiffness=0;
	length10=length10_PlusDelta=force10=force10_PlusDelta=CVector(0,0);
}

Spring::Spring(double length, double stiff):InertialElement(id++){
	restLength=length;
	stiffness=stiff;
	length10=length10_PlusDelta= CVector(restLength, 0);
	force10=force10_PlusDelta=CVector(0,0);
}

void Spring::attachEnd(Ball * pb){
	switch(attachBall.size()){
		case 0:
			attachBall.push_back(pb);
			pb->setSpring(this); 
			break;
		case 1:
			if(attachBall[0]!=pb){
				attachBall.push_back(pb);
				pb->setSpring(this); 
			}
			break;
		default:
			break;
	}
}

string Spring::getDescription() const{
	return "RestLength\tActualLength\tForce";
}

string Spring::getState() const{
	return to_string(restLength)+"\t"+to_string(length10.module())+"\t"+to_string(force10.module());
}

void Spring::computeNextState(double delta_t, MyWorld * world){
	if(attachBall.size()==2){
		length10_PlusDelta=attachBall[1]->getPosition()-attachBall[0]->getPosition();
		force10_PlusDelta=length10*stiffness*(1-restLength/(length10.module()));
	}
	else{
		length10_PlusDelta=length10;
		force10_PlusDelta=force10;
	}
	
}
void Spring::updateState(){
    	length10=length10_PlusDelta;
    	force10=force10_PlusDelta;
}

CVector Spring::getForce(Ball *pb)const{
    	if(attachBall[0]==pb)
    		return force10;
    	else 
    		return force10*(-1);
}
