#ifndef SPRING_H
#define SPRING_H

class Ball;

#include <string>
#include "CVector.h"
#include "InertialElement.h"
#include "PhysicsElement.h"
#include "MyWorld.h"
#include <vector>

using namespace std;

class Spring: public InertialElement{
private:
	static int id;
	double stiffness, restLength;
	CVector length10, length10_PlusDelta, force10, force10_PlusDelta;
	vector<Ball*> attachBall;
public:
	Spring();
	Spring(double length, double stiff);
	void attachEnd(Ball * pb);
	virtual string getDescription() const;
    virtual string getState() const;
    CVector getForce(Ball *pb)const;
    virtual const PhysicsElement * collideWith(const Ball *b) const{return NULL;} 
    virtual void computeNextState(double delta_t, MyWorld * world); 
    virtual void updateState();
};
#endif