#include <iostream>
#include <cstdlib>  // c++ exit
#include "MyWorld.h"
#include "Ball.h"
#include "CVector.h"
#include "Container.h"

using namespace std;

int main(int argvc, char * argv[]) {
	if (argvc != 4)  {
        	cout << "usage: "<< argv[0] << " <delta_time[s]> <end_time[s]> <sampling_time[s]>" << endl;
        	exit(-1);
	}
	double deltaTime = /*0.001; */atof(argv[1]);    // [s]
	double endTime = /*10.0;*/atof(argv[2]);      // [s]
	double samplingTime = /*0.1; */atof(argv[3]); // [s]
      MyWorld world(cout);
      
      double mass = 1.0;      // 1 [kg] 
      double radius = 0.1;    // 10 [cm] 
      CVector position(1,1);  // [m] 
      CVector speed(0.5,0.5);     //  [m/s]
      Ball b0(mass, radius, position, speed);
      position.set(2,2);
      speed.set(-0.5,-0.5);
      Ball b1(mass, radius, position, speed);
      Container c(CVector(0,3),CVector(3,0));
      world.addElement(&b0);
      world.addElement(&b1);
      world.addElement(&c);
      world.simulate(deltaTime, endTime, samplingTime); // delta time[s], total simulation time [s].
}
